> For the complete documentation index, see [llms.txt](https://p2p-2.gitbook.io/watcher-api/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://p2p-2.gitbook.io/watcher-api/reference/api-reference/tokens.md).

# Tokens

## Get the list of tokens

## Method returns the list of supported tokens.

<mark style="color:blue;">`GET`</mark> `https://api.web3watcher.fi/v1/tokens/list`

List of names for tokens that you can use inside of the others requests.

#### Request Body

| Name   | Type | Description                   |
| ------ | ---- | ----------------------------- |
| offset | int  | the number of tokens per page |
| page   | int  | num of page                   |

{% tabs %}
{% tab title="200 Pet successfully created" %}

```javascript
{
    "status":"200",
    "message":"Success",
    "result":[
        {
        "token_symbol": "eth",
        "token_symbol": "steth",
        "token_symbol": "ldo",
        "token_symbol": "matic",
        "token_symbol": "crv",
        },
    ],
    "offset": 5,
    "page": 1,
}
```

{% endtab %}

{% tab title="401 Permission denied" %}

```json
{
    "status":"401",
    "message":"Permission denied",
    "result":[],
    "offset": 5,
    "page": 1,
}
```

{% endtab %}
{% endtabs %}

## Get the token overview

## Method returns the overview and current metrics for token.

<mark style="color:blue;">`GET`</mark> `https://api.web3watcher.fi/v1/tokens/list/{token_symbol}`

The data is represented for the current time.

#### Request Body

| Name                                            | Type   | Description                     |
| ----------------------------------------------- | ------ | ------------------------------- |
| token\_symbol<mark style="color:red;">\*</mark> | string | symbol of token from token list |

{% tabs %}
{% tab title="200 Pet successfully created" %}

```javascript
{
    "status":"200",
    "message":"Success",
    "result":[
        {
        "token_symbol": "eth",
        "freshness_date": "2023-10-18 01:00:00:0000",
        "token_price": 1565.38,
        "token_supply": 120261074.81,
        "token_type": "erc-20",
        "defi_in":[
                {
                "defi_name":"lido",
                "defi_contract":"0xae7ab96520de3a18e5e111b5eaab095312d7fe84",
                },
                {
                "defi_name":"curve",
                "defi_contract":"0xD533a949740bb3306d119CC777fa900bA034cd52",
                },
                ...
        ],
        },
    ]
}
```

{% endtab %}

{% tab title="401 Permission denied" %}

```json
{
    "status":"401",
    "message":"Permission denied",
    "result":[],
}
```

{% endtab %}
{% endtabs %}

## Get the token liquidity

## Method returns the list of liquidity positions in deFi/CEXes.

<mark style="color:blue;">`GET`</mark> `https://api.web3watcher.fi/v1/tokens/liquidity/{token_symbol}`

The data is represented for the current time.

#### Request Body

| Name                                            | Type   | Description                               |
| ----------------------------------------------- | ------ | ----------------------------------------- |
| token\_symbol<mark style="color:red;">\*</mark> | string | symbol of token from token list           |
| liquidity\_category                             | string | dex / cex / lending-borrowing / bridges   |
| offset                                          | int    | number of positions of liquidity per page |
| pagination                                      | int    | num of page                               |

{% tabs %}
{% tab title="200 Pet successfully created" %}

```javascript
{
    "status":"200",
    "message":"Success",
    "result":[
        {
        "token_symbol": "eth",
        "freshness_date": "2023-10-25 17:25:35:0000",
        "liquidity_category": "dex",
        "positions": [
            {
                "position_id": "0xdc24316b9ae028f1497c275eb9192a3ea0f67022",
                "position_name": "eth-steth",
                "position_current_daily_apy": 0.0193,
                "defi_name": "curve",
                "liquidity" : [
                    {
                        "token_symbol": "eth",
                        "token_amount": 59980.91841,
                        "token_price": 1792.89,
                    },
                    {
                        "token_symbol": "steth",
                        "token_amount": 60736.6184,
                        "token_price": 1788.11,
                    },
                ],
            },
        ],
        },
    ],
    "offset": 1,
    "pagination": 1,
}
```

{% endtab %}

{% tab title="401 Permission denied" %}

```json
{
    "status":"401",
    "message":"Permission denied",
    "result":[],
    "offset": 1,
    "pagination": 1,
}
```

{% endtab %}
{% endtabs %}

## Get the liquidity history

## Method returns the history of liquidity for the particular position.

<mark style="color:blue;">`GET`</mark> `https://api.web3watcher.fi/v1/tokens/positions/{position_id}`

Historical data for positions which you may receive by previous method.

#### Request Body

| Name                                           | Type   | Description                            |
| ---------------------------------------------- | ------ | -------------------------------------- |
| position\_id<mark style="color:red;">\*</mark> | string | The address of the pool / bridge / cex |
| offset                                         | int    | the number of rows for history data    |
| pagination                                     | int    | num of page                            |

{% tabs %}
{% tab title="200 Pet successfully created" %}

```javascript
{
    "status":"200",
    "message":"Success",
    "result":[
        {
        "token_symbol": "eth",
        "freshness_date": "2023-10-25 17:25:35:0000",
        "liquidity_category": "dex",
        "position_id": "0xdc24316b9ae028f1497c275eb9192a3ea0f67022",
        "position_name": "eth-steth",
        "defi_name": "curve",
        "position_daily_apy": 0.0193,
        "liquidity_history":[
            {
            "token_symbol": "eth",
            "token_amount": 59980.91841,
            "token_price": 1792.89,
            },
            {
            "token_symbol": "steth",
            "token_amount": 60736.6184,
            "token_price": 1788.11,
            },
                ],
        },
        {
        "token_symbol": "eth",
        "freshness_date": "2023-10-25 17:20:00:0000",
        "liquidity_category": "dex",
        "position_id": "0xdc24316b9ae028f1497c275eb9192a3ea0f67022",
        "position_name": "eth-steth",
        "defi_name": "curve",
        "position_daily_apy": 0.0192,
        "liquidity_history":[
            {
            "token_symbol": "eth",
            "token_amount": 59979.293,
            "token_price": 1791.36,
            },
            {
            "token_symbol": "steth",
            "token_amount": 60678.537,
            "token_price": 1787.98,
            },
            ],
         },
    ],
    "offset": 2,
    "pagination": 1,
}
```

{% endtab %}

{% tab title="401 Permission denied" %}

```json
{
    "status":"401",
    "message":"Permission denied",
    "result":[],
    "offset": 2,
    "pagination": 1,
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://p2p-2.gitbook.io/watcher-api/reference/api-reference/tokens.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
